=== doc/Common/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/manual.h.in ${CMAKE_CURRENT_BINARY_DIR}/manual.h @ONLY)
