=== debian/rules ===
#!/usr/bin/make -f

OCT_SITE_DIR = $(shell octave-config --oct-site-dir | sed -e 's|^/||')


%: debian/octave-nds2-client.dirs debian/octave-nds2-client.install
	dh $@ --buildsystem=cmake --with python3

debian/octave-nds2-client.dirs:
	echo $(OCT_SITE_DIR) >$@

debian/octave-nds2-client.install:
	echo 'usr/libexec/nds2-client/octave/*.oct*' $(OCT_SITE_DIR) >$@
	echo 'etc/nds2-client/nds2-client-octave.cfg' >> $@

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_SASL=yes -DWITH_GSSAPI=no -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_EXPORT_COMPILE_COMMANDS=1


# clean out .la files which are discouraged from being installed
# (lintian)
override_dh_auto_install:
	dh_auto_install
	[ -x /usr/bin/dh_numpy ] && dh_numpy || :
	find . -name '*.la' -delete
	mv -f debian/tmp/usr/etc debian/tmp/ || true

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/octave-nds2-client.*
